unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AddFlowLib_TLB, ExtCtrls;

type
  TfrmWorkFlow = class(TForm)
    AddFlow1: TAddFlow;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure AddFlow1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AddFlow1DblClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmWorkFlow: TfrmWorkFlow;
  ActorName: string;
  RoleName: string;

implementation

uses Main, Actor, ActiveX, AxCtrls;

{$R *.DFM}

procedure TfrmWorkFlow.FormResize(Sender: TObject);
begin
  Tag := 1;
  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth
  end
end;

procedure TfrmWorkFlow.FormCreate(Sender: TObject);
var
  node: array[1..19] of afNode;
  lnkx: afLink;
  pt: afLinkPoint;
  crlf: string;
  temp: IPictureDisp;  // IPictureDisp is DispInterface for Picture
begin
  crlf := Chr(13) + Chr(10);
  Tag := 1;
  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth;

    { Just to accelerate display (Don't forget to reset it at the end) }
    Repaint := False;
    
    DrawColor := 32768;

    { Create nodes }
    node[1] := Nodes.Add(1050, 60, 1300, 960);
    node[1].FillColor := RGB(255, 255, 192);
    node[1].Text := 'Order Entry';
    GetOlePicture(Image3.Picture, temp);
    node[1].Picture := temp;

    node[2] := Nodes.Add(1470, 1570, 450, 450);
    node[2].FillColor := 16777215;
    node[2].Text := 'and';

    node[3] := Nodes.Add(1425, 4815, 415, 480);
    node[3].FillColor := 16777215;

    node[4] := Nodes.Add(100, 3285, 1115, 525);
    node[4].Shape := afRoundRect;
    node[4].FillColor := 8454143;
    node[4].Text := 'Inventory Check';

    node[5] := Nodes.Add(2070, 2700, 1275, 465);
    node[5].Shape := afRoundRect;
    node[5].FillColor := 8454143;
    node[5].Text := 'Compile Reference';

    node[6] := Nodes.Add(2070, 3960, 1275, 435);
    node[6].Shape := afRoundRect;
    node[6].FillColor := 8454143;
    node[6].Text := 'Evaluate Reference';

    node[7] := Nodes.Add(2460, 4800, 480, 480);
    node[7].Shape := afDiamond;
    node[7].FillColor := 12632256;
    node[7].Text := 'or';

    node[8] := Nodes.Add(1380, 6390, 480, 480);
    node[8].Shape := afDiamond;
    node[8].FillColor := 12632256;
    node[8].Text := 'or';

    node[9] := Nodes.Add(1050, 5620, 1150, 530);
    node[9].Shape := afRoundRect;
    node[9].FillColor := 8454143;
    node[9].Text := 'Order Evaluation';

    node[10] := Nodes.Add(30, 7275, 1365, 915);
    node[10].Shape := afRoundRect;
    node[10].FillColor := 8454143;
    node[10].Text := 'Letter of regret';
    GetOlePicture(Image1.Picture, temp);
    node[10].Picture := temp;

    node[11] := Nodes.Add(2010, 7425, 1185, 390);
    node[11].Shape := afRoundRect;
    node[11].FillColor := 8454143;
    node[11].Text := 'Billing';

    node[12] := Nodes.Add(2025, 8310, 1170, 375);
    node[12].Shape := afRoundRect;
    node[12].FillColor := 8454143;
    node[12].Text := 'Shipping';

    node[13] := Nodes.Add(1380, 10005, 1110, 915);
    node[13].DrawColor := 32768;
    node[13].FillColor := RGB(255, 255, 192);
    node[13].Text := 'Archive';
    GetOlePicture(Image2.Picture, temp);
    node[13].Picture := temp;

    Shape := afRoundRect;
    DrawColor := RGB(0, 0, 0);

    node[14] := Nodes.Add(45, 1135, 1215, 640);
    node[14].Transparent := True;
    node[14].UserData := 2;
    node[14].FillColor := 15269887;
    node[14].Text := 'Jane' + crlf + 'INVENTORY MANAGER';

    node[15] := Nodes.Add(3000, 610, 1075, 525);
    node[15].Transparent := True;
    node[15].UserData := 2;
    node[15].FillColor := 15269887;
    node[15].Text := 'Paul' + crlf + 'SECRETARY';

    node[16] := Nodes.Add(3000, 5640, 1100, 480);
    node[16].Transparent := True;
    node[16].UserData := 2;
    node[16].FillColor := 15269887;
    node[16].Text := 'Lydia' + crlf + 'SECRETARY';

    node[17] := Nodes.Add(4000, 7770, 600, 540);
    node[17].DrawStyle := afDot;
    node[17].Transparent := true;
    node[17].UserData := 2;
    node[17].FillColor := 15269887;
    node[17].Text := 'Bill';

    node[18] := Nodes.Add(105, 9030, 945, 600);
    node[18].Transparent := True;
    node[18].UserData := 2;
    node[18].FillColor := 15269887;
    node[18].Text := 'Jack' + crlf + 'ARCHIVER';

    DrawColor := 32768;

    { Create links }
    lnkx := node[1].OutLinks.Add(node[2]);

    lnkx := node[2].OutLinks.Add(node[4]);
    pt := CoafLinkPoint.Create;
    pt.X := 795;
    pt.Y := 2130;
    lnkx.ExtraPoints.Add(pt);

    lnkx := node[5].OutLinks.Add(node[6]);

    lnkx := node[4].OutLinks.Add(node[3]);
    pt.X := 795;
    pt.Y := 5040;
    lnkx.ExtraPoints.Add(pt);

    lnkx := node[6].OutLinks.Add(node[7]);

    lnkx := node[7].OutLinks.Add(node[3]);
    lnkx.Text := 'Yes';

    lnkx := node[3].OutLinks.Add(node[9]);
  
    lnkx := node[9].OutLinks.Add(node[8]);

    lnkx := node[8].OutLinks.Add(node[10]);
    pt.X := 705;
    pt.Y := 6795;
    lnkx.ExtraPoints.Add(pt);
    lnkx.Text := 'Reject';

    lnkx := node[8].OutLinks.Add(node[11]);
    pt.X := 2595;
    pt.Y := 6795;
    lnkx.ExtraPoints.Add(pt);
    lnkx.Text := 'Accept';

    lnkx := node[11].OutLinks.Add(node[12]);

    lnkx := node[12].OutLinks.Add(node[13]);
    lnkx.DrawColor := 32768;

    lnkx := node[10].OutLinks.Add(node[13]);
    lnkx.DrawColor := 32768;

    lnkx := node[2].OutLinks.Add(node[5]);
    pt.X := 2700;
    pt.Y := 2115;
    lnkx.ExtraPoints.Add(pt);

    lnkx := node[7].OutLinks.Add(node[5]);
    pt.X := 4020;
    pt.Y := 5040;
    lnkx.ExtraPoints.Add(pt);
    pt.X := 4020;
    pt.Y := 2925;
    lnkx.ExtraPoints.Add(pt);
    lnkx.Text := 'No';

    { Default properties for the end }
    DrawWidth := 1;
    DrawColor := RGB(0, 0, 0);
    Shape := afRoundRect;
    ArrowDst := afEmptyCircle;
    ArrowOrg := afEmptyCircle;
    Transparent := True;
    LinkStyle := afBezier;

    { Now continue }

    lnkx := node[14].OutLinks.Add(node[1]);
    
    lnkx := node[15].OutLinks.Add(node[5]);
    
    lnkx := node[15].OutLinks.Add(node[6]);
    pt.X := 4515;
    pt.Y := 2560;
    lnkx.ExtraPoints.Add(pt);
    pt.X := 4200;
    pt.Y := 3000;
    lnkx.ExtraPoints.Add(pt);

    lnkx := node[14].OutLinks.Add(node[4]);
    pt.X := 450;
    pt.Y := 2460;
    lnkx.ExtraPoints.Add(pt);

    lnkx := node[16].OutLinks.Add(node[9]);

    lnkx := node[17].OutLinks.Add(node[11]);
    lnkx.DrawStyle := afDot;
    
    lnkx := node[17].OutLinks.Add(node[12]);
    lnkx.DrawStyle := afDot;

    lnkx := node[18].OutLinks.Add(node[10]);

    lnkx := node[18].OutLinks.Add(node[13]);

    Repaint := True;
  end
end;

procedure TfrmWorkFlow.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
  MainForm.WorkFlow1.Enabled := True;
end;

procedure TfrmWorkFlow.FormActivate(Sender: TObject);
begin
  MainForm.ActivateForm;
end;

procedure TfrmWorkFlow.FormDeactivate(Sender: TObject);
begin
  MainForm.DeactivateForm;
end;

procedure TfrmWorkFlow.AddFlow1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    AddFlow1.DeleteSel;
end;

procedure TfrmWorkFlow.AddFlow1DblClick(Sender: TObject);
var
  node: afNode;
  s: string;
  len: integer;
begin
  node := AddFlow1.SelectedNode;
  If node <> Nil then
  begin
    if node.UserData = 2 then
    begin
      s := node.Text;
      len := Pos(Chr(13), s);
      ActorName := copy(s, 1, len - 1);
      len := Pos(Chr(10), s);
      RoleName := copy(s, len + 1, Length(s) - len);
      ActorDlg.ShowModal;
      node.Text := ActorName + Chr(13) + Chr(10) + RoleName;
    end
  end
end;

end.
