unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AddFlowLib_TLB, ExtCtrls;

type
  TfrmNetwork = class(TForm)
    AddFlow1: TAddFlow;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AddFlow1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AddFlow1DblClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmNetwork: TfrmNetwork;

implementation

uses Main, ActiveX, AxCtrls, ItemProp;

{$R *.DFM}

procedure TfrmNetwork.FormResize(Sender: TObject);
begin
  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth
  end
end;

procedure TfrmNetwork.FormCreate(Sender: TObject);
var
  node: array[1..20] of afNode;
  lnkx: afLink;
  temp: IPictureDisp;  // IPictureDisp is DispInterface for Picture
begin
  Tag := 2;
  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth;

    { Just to accelerate display }
    Repaint := False;

    DrawStyle := afInsideSolid;
    ArrowDst := 0;

    { Create nodes }
    node[1] := Nodes.Add(4455, 180, 2685, 2955);
    node[1].ForeColor := 255;
    node[1].DrawStyle := afDot;
    node[1].DrawColor := 255;
    node[1].Alignment := afCenterTOP;
    node[1].Transparent := True;
    node[1].Text := Chr(13) + Chr(10) + 'INTERNET';

    node[2] := Nodes.Add(240, 150, 3525, 3105);
    node[2].ForeColor := 255;
    node[2].DrawColor := 255;
    node[2].DrawStyle := afDot;
    node[2].Alignment := afCenterTOP;
    node[2].Transparent := True;
    node[2].Text := Chr(13) + Chr(10) + 'INTRANET';

    node[3] := Nodes.Add(540, 1935, 2970, 45); {LAN}
    node[3].Shape := afRectangle;
    node[3].FillColor := 0;

    node[4] := Nodes.Add(3060, 2115, 240, 255); {Router}
    node[4].Shape := afWestTriangle;
    node[4].FillColor := 0;

    node[5] := Nodes.Add(5025, 2100, 240, 240); {Router}
    node[5].Shape := afEastTriangle;
    node[5].FillColor := 0;

    node[6] := Nodes.Add(690, 675, 640, 945); {Server}
    node[6].FillColor := 16777215;
    node[6].DrawStyle := afTransparent;
    node[6].Alignment := afCenterTOP;
    node[6].Shape := afRectangle;
    node[6].Transparent := True;
    node[6].Text := 'Server NT';
    GetOlePicture(Image4.Picture, temp);
    node[6].Picture := temp;

    node[7] := Nodes.Add(1710, 1155, 480, 480); {PC client}
    node[7].FillColor := 16777215;
    node[7].DrawStyle := afTransparent;
    node[7].Shape := 1;
    node[7].Transparent := True;
    GetOlePicture(Image2.Picture, temp);
    node[7].Picture := temp;

    node[8] := Nodes.Add(1245, 2340, 480, 465);
    node[8].FillColor := 16777215;
    node[8].DrawStyle := afTransparent;
    node[8].Shape := 1;
    node[8].Transparent := True;   
    GetOlePicture(Image2.Picture, temp);
    node[8].Picture := temp;

    node[9] := Nodes.Add(2175, 2340, 480, 480);
    node[9].FillColor := 16777215;
    node[9].DrawStyle := afTransparent;
    node[9].Shape := afRectangle;
    node[9].Transparent := True;
    GetOlePicture(Image3.Picture, temp);
    node[9].Picture := temp;

    node[10] := Nodes.Add(1920, 1905, 60, 60);
    node[10].FillColor := 0;
    node[10].Shape := afRectangle;

    node[11] := Nodes.Add(2385, 1935, 60, 60);
    node[11].FillColor := 0;
    node[11].Shape := afRectangle;

    node[12] := Nodes.Add(1440, 1935, 60, 60);
    node[12].FillColor := 0;
    node[12].Shape := afRectangle;

    node[13] := Nodes.Add(3165, 1950, 60, 60);
    node[13].FillColor := 0;
    node[13].Shape := afRectangle;

    node[14] := Nodes.Add(960, 1905, 60, 60);
    node[14].FillColor := 0;
    node[14].Shape := afRectangle;

    node[15] := Nodes.Add(5790, 750, 480, 375);
    node[15].FillColor := 8454143;

    node[16] := Nodes.Add(5805, 1995, 480, 390);
    node[16].FillColor := 8454143;

    node[17] := Nodes.Add(5130, 2475, 435, 455);
    node[17].FillColor := 8454143;

    node[18] := Nodes.Add(6570, 885, 360, 390);
    node[18].Transparent := True;
    node[18].DrawStyle := afTransparent;
    node[18].Text := '...';

    node[19] := Nodes.Add(6585, 1605, 360, 390);
    node[19].Transparent := True;
    node[19].DrawStyle := afTransparent;
    node[19].Text :=  '...';

    node[20] := Nodes.Add(4620, 1290, 990, 585);
    node[20].FillColor := 8454143;
    node[20].Text := 'Internet provider';

    { owners by creating rigid links }
    Rigid := True;
    Hidden := True;

    { The five little black boxes are owned by the "LAN" node }
    lnkx := node[3].OutLinks.Add(node[10]);
    lnkx.Selectable := False;

    lnkx := node[3].OutLinks.Add(node[11]);
    lnkx.Selectable := False;

    lnkx := node[3].OutLinks.Add(node[12]);
    lnkx.Selectable := False;

    lnkx := node[3].OutLinks.Add(node[13]);
    lnkx.Selectable := False;

    lnkx := node[3].OutLinks.Add(node[14]);
    lnkx.Selectable := False;

    { All other nodes inside the INTRANET node are owned by this node }
    lnkx := node[2].OutLinks.Add(node[3]);
    lnkx.Selectable := False;
    
    lnkx := node[2].OutLinks.Add(node[4]);
    lnkx.Selectable := False;
    
    lnkx := node[2].OutLinks.Add(node[6]);
    lnkx.Selectable := False;
    
    lnkx := node[2].OutLinks.Add(node[7]);
    lnkx.Selectable := False;
    
    lnkx := node[2].OutLinks.Add(node[8]);
    lnkx.Selectable := False;
    
    lnkx := node[2].OutLinks.Add(node[9]);
    lnkx.Selectable := False;
    
    { All nodes inside the INTERNET node are owned by this node }
    lnkx := node[1].OutLinks.Add(node[20]);
    lnkx.Selectable := False;
    
    lnkx := node[1].OutLinks.Add(node[19]);
    lnkx.Selectable := False;
    
    lnkx := node[1].OutLinks.Add(node[18]);
    lnkx.Selectable := False;
    
    lnkx := node[1].OutLinks.Add(node[17]);
    lnkx.Selectable := False;
    
    lnkx := node[1].OutLinks.Add(node[16]);
    lnkx.Selectable := False;
    
    lnkx := node[1].OutLinks.Add(node[15]);
    lnkx.Selectable := False;
    
    lnkx := node[1].OutLinks.Add(node[5]);
    lnkx.Selectable := False;
    
    { Create true visible links. }
    Hidden := False;
    Rigid := False;
    
    { - the link between intranet and internet }
    lnkx := node[5].OutLinks.Add(node[4]);
    lnkx.DrawWidth := 2;
    
    { - the other links }
    DrawColor := RGB(0, 255, 0);
    lnkx := node[7].OutLinks.Add(node[10]);
    lnkx := node[9].OutLinks.Add(node[11]);
    lnkx := node[8].OutLinks.Add(node[12]);
    lnkx := node[4].OutLinks.Add(node[13]);
    lnkx := node[5].OutLinks.Add(node[20]);
    lnkx := node[20].OutLinks.Add(node[15]);
    lnkx := node[16].OutLinks.Add(node[20]);
    lnkx := node[16].OutLinks.Add(node[15]);
    lnkx := node[16].OutLinks.Add(node[17]);
    lnkx := node[15].OutLinks.Add(node[18]);
    lnkx := node[16].OutLinks.Add(node[19]);
    lnkx := node[6].OutLinks.Add(node[14]);
    
    Repaint := True;
  end
end;

procedure TfrmNetwork.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  MainForm.Network1.Enabled := True;
end;

procedure TfrmNetwork.FormDeactivate(Sender: TObject);
begin
  MainForm.DeactivateForm;
end;

procedure TfrmNetwork.FormActivate(Sender: TObject);
begin
  MainForm.ActivateForm;
end;

procedure TfrmNetwork.AddFlow1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    AddFlow1.DeleteSel;
end;

procedure TfrmNetwork.AddFlow1DblClick(Sender: TObject);
begin
  ItemPropDlg.ShowModal;
end;

end.
