unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AddFlowLib_TLB, Menus;

type
  TfrmDiagram = class(TForm)
    AddFlow1: TAddFlow;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AddFlowMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AddFlowMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure AddFlow1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

const TWIPS_PER_INCH :integer = 15;

var
  frmDiagram: TfrmDiagram;
  flag: Boolean;
  NodeNumber: LongInt;
  X0: LongInt;        
  Y0: LongInt;

implementation

uses Main;
{$R *.DFM}

procedure TfrmDiagram.FormResize(Sender: TObject);
begin
  Tag := 3;
  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth
  end
end;

procedure TfrmDiagram.FormCreate(Sender: TObject);
var
  node: array[1..4] of afNode;
  lnkx: afLink;
begin
  NodeNumber := 1;
  flag := False;

  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth;

    { Just to accelerate display (Don't forget to reset it at the end) }
    Repaint := False;

    DrawColor := RGB(255, 0, 0);
    FillColor := RGB(255, 255, 192);
    
    { Create nodes }
    node[1] := Nodes.Add(600, 200, 500, 500);
    node[1].Text := IntToStr(NodeNumber);
    NodeNumber := NodeNumber + 1;

    node[2] := Nodes.Add(2100, 200, 500, 500);
    node[2].Text := IntToStr(NodeNumber);
    NodeNumber := NodeNumber + 1;

    node[3] := Nodes.Add(1600, 1700, 500, 500);
    node[3].Text := IntToStr(NodeNumber);
    NodeNumber := NodeNumber + 1;

    node[4] := Nodes.Add(100, 1700, 500, 500);
    node[4].Text := IntToStr(NodeNumber);
    NodeNumber := NodeNumber + 1;
    
    { Create links }
    lnkx := node[1].OutLinks.Add(node[2]);
    lnkx := node[2].OutLinks.Add(node[3]);
    lnkx := node[3].OutLinks.Add(node[4]);
    lnkx := node[1].OutLinks.Add(node[4]);
    lnkx := node[1].OutLinks.Add(node[3]);

    Repaint := True;
  end
end;

procedure TfrmDiagram.AddFlowMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (AddFlow1.PointedArea = 5) then
  begin
    flag := True;
    X0 := X;
    Y0 := Y;
  end
end;

procedure TfrmDiagram.AddFlowMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Width: Real;
  Height: Real;
  Left: Real;
  Top: Real;
  Org: afNode;
  Dst: afNode;
  lnk: afLink;
  Action: LongInt;
begin
  Action := AddFlow1.LastUserAction;
  if Action = afNodeCreation then
  begin
    AddFlow1.SelectedNode.Text := IntToStr(NodeNumber);
    NodeNumber := NodeNumber + 1;
  end;

  if flag = True then  { The user has tried to create a link. }
  begin
    flag := False;
    
    { If a link has just been created, don't create a new one ==> exit
      This is the normal situation where the mouse is over a node. }
    {if Action = afLinkCreation then
      end;}

    { Avoid to create anything if the mouse move is too small. }
    {If (Abs(X - X0) < 300 And Abs(Y - Y0) < 300) Then
      end;}

    { The origin node of the next created link is the selected node }
    Org := AddFlow1.SelectedNode;

    { Position and size of next created node }
    Width := 500;
    Height := 500;
    Left := (TWIPS_PER_INCH * X + AddFlow1.xScroll) * 100 / AddFlow1.xZoom - Width / 2;
    Top := (TWIPS_PER_INCH * Y + AddFlow1.yScroll) * 100 / AddFlow1.yZoom - Height / 2;

    { Create destination node }
    Dst := AddFlow1.Nodes.Add(Left, Top, Width, Height);
    if (Dst <> nil) then
    begin
      Dst.Text := IntToStr(NodeNumber);
      NodeNumber := NodeNumber + 1;

      { Create the link from origin to destination }
      lnk := Org.OutLinks.Add(Dst);
    end
  end;
end;

procedure TfrmDiagram.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  MainForm.Diagram1.Enabled := True;
end;

procedure TfrmDiagram.FormActivate(Sender: TObject);
begin
  MainForm.ActivateForm;
end;

procedure TfrmDiagram.FormDeactivate(Sender: TObject);
begin
  MainForm.DeactivateForm;
end;

procedure TfrmDiagram.AddFlow1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    AddFlow1.DeleteSel;
end;

end.
