unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AddFlowLib_TLB, ExtCtrls;

type
  TfrmFlowchart = class(TForm)
    AddFlow1: TAddFlow;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure CursorShape;
    procedure AddFlowMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AddFlow1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmFlowchart: TfrmFlowchart;

implementation

uses Main, ActiveX, AxCtrls;

{$R *.DFM}

procedure TfrmFlowchart.FormCreate(Sender: TObject);
var
  node: array[1..6] of afNode;
  lnkx: afLink;
  pt: afLinkPoint;
  temp: IPictureDisp;  // IPictureDisp is DispInterface for Picture
begin
  Tag := 4;
  pt := CoafLinkPoint.Create;
  
  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth;

    { Just to accelerate display (Don't forget to reset it at the end) }
    Repaint := False;

    { Default settings }
    AutoSize := afAdjustNodeSizetoPicture;
    Shape := afRectangle;
    LinkStyle := afBezier;

    { Create nodes }
    node[1] := Nodes.Add(200, 200, 800, 800);
    node[1].Shape := afRoundRect;
    node[1].Text := 'BEGIN';
    GetOlePicture(Image2.Picture, temp);
    node[1].Picture := temp;

    node[2] := Nodes.Add(200, 2200, 800, 800);
    node[2].Text := 'STEP1';
    GetOlePicture(Image1.Picture, temp);
    node[2].Picture := temp;

    node[3] := Nodes.Add(2200, 2200, 800, 800);
    node[3].Shape := afDiamond ;
    node[3].Text := 'Success?';
    GetOlePicture(Image3.Picture, temp);
    node[3].Picture := temp;

    node[4] := Nodes.Add(4200, 700, 800, 800);
    node[4].Text := 'STEP3';
    GetOlePicture(Image4.Picture, temp);
    node[4].Picture := temp;

    node[5] := Nodes.Add(6200, 2200, 800, 800);
    node[5].Shape := afRoundRect;
    node[5].Text := 'END';           
    GetOlePicture(Image2.Picture, temp);
    node[5].Picture := temp;

    node[6] := Nodes.Add(4200, 3400, 800, 800);
    node[6].Shape := afEllipse;
    node[6].Text := 'STEP2';  
    GetOlePicture(Image4.Picture, temp);
    node[6].Picture := temp;

    DrawStyle := 0;
    ArrowDst := afEmptyArrow30;
    ForeColor := RGB(0, 0, 255);
    DrawColor := RGB(0, 0, 255);

    { Create lnkxs }
    lnkx := node[1].OutLinks.Add(node[2]);
    lnkx := node[2].OutLinks.Add(node[3]);

    lnkx := node[3].OutLinks.Add(node[4]);
    pt.X := 2640;
    pt.Y := 1840;
    lnkx.ExtraPoints.Add(pt);
    pt.X := 2840;
    pt.Y := 1440;
    lnkx.ExtraPoints.Add(pt);
    lnkx.Text := 'YES';

    lnkx := node[3].OutLinks.Add(node[6]);
    pt.X := 2840;
    pt.Y := 4840;
    lnkx.ExtraPoints.Add(pt);
    pt.X := 3040;
    pt.Y := 3440;
    lnkx.ExtraPoints.Add(pt);
    lnkx.Text := 'NO';

    lnkx := node[4].OutLinks.Add(node[5]);
    pt.X := 6040;
    pt.Y := 1240;
    lnkx.ExtraPoints.Add(pt);
    pt.X := 6740;
    pt.Y := 1540;
    lnkx.ExtraPoints.Add(pt);
    
    lnkx := node[6].OutLinks.Add(node[5]);
    
    lnkx := node[4].OutLinks.Add(node[1]);
    pt.X := 2440;
    pt.Y := 940;
    lnkx.ExtraPoints.Add(pt);
    pt.X := 3240;
    pt.Y := 140;
    lnkx.ExtraPoints.Add(pt);

    Repaint := True;
  end
end;

procedure TfrmFlowchart.FormResize(Sender: TObject);
begin
  with AddFlow1 do
  begin
    Left := 0;
    Top := 0;
    Height := Self.ClientHeight;
    Width := Self.ClientWidth
  end
end;

procedure TfrmFlowchart.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
  MainForm.Flowchart1.Enabled := True;
end;

procedure TfrmFlowchart.FormActivate(Sender: TObject);
begin
  MainForm.ActivateForm;
end;

procedure TfrmFlowchart.FormDeactivate(Sender: TObject);
begin
  MainForm.DeactivateForm;
end;

procedure TfrmFlowchart.CursorShape;
begin
  Case AddFlow1.PointedArea of
  0: AddFlow1.MousePointer := 8;
  1: AddFlow1.MousePointer := 7;
  2: AddFlow1.MousePointer := 6;
  3: AddFlow1.MousePointer := 9;
  7: if AddFlow1.SelectMode = True then
       AddFlow1.MousePointer := 2;
     else
       AddFlow1.MousePointer := 0;
  end
end;

procedure TfrmFlowchart.AddFlowMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  CursorShape;
end;

procedure TfrmFlowchart.AddFlow1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    AddFlow1.DeleteSel;
end;

end.
