unit Main;

interface

uses Windows, SysUtils, Classes, Forms, Controls, Menus,
  AddFlowLib_TLB, StdCtrls;

const
  INFO11 = ' In this example, the purpose is to associate actors (Transparent blue nodes) to task items (yellow nodes). ';
  INFO12 = ' You cannot change the process diagram. You can only move and resize nodes or stretch links. This limitation is added here in order to demonstrate how easy it is to customize your application.';
  INFO13 = ' Therefore, you may create new actor node or change actor names by double-clicking over actor node and you may also create links between actor nodes and task nodes (Ex.: Jane - Order Entry). A dialog box is displayed when The DBLCLICK event is received.';
  INFO14 = ' Note that when mouse is over a sizing square, the mouse pointer is changing, depending on its position. (See PointedArea property in the help file)';

  INFO21 = ' Double-click on an item (node or link) and you''ll be able to change the properties of this item. In this example, we have implemented a hierarchy between nodes. ';
  INFO22 = ' For instance the long flat node (which symbolizes the local network) owns 5 little nodes implementing stubs. The ''INTERNET'' node owns all nodes inside itself. ';
  INFO23 = ' See Rigid property in order to know how to create ownership between nodes.';

  INFO31 = ' Here, you have a way to combine the node and link add into a single step. ';
  INFO32 = ' You bring the mouse cursor into the handle at the center of the selected node, press the left button, move the mouse where you want but not over a node. Then you release the left button and you''ll see that a node and a link are created together.';
  INFO33 = ' Note also that when you create a node with the mouse, there is a mimimal node size (See Nodes.Add event in the help file to see how to do that).';
  INFO34 = ' Note that when mouse is over a sizing square, the mouse pointer is changing, depending on its position. (See PointedArea property in the help file)';

  INFO41 = ' In this example, node sizes are adjusted to picture sizes (See property AutoSize). In such a case, text is displayed inside picture.';
  INFO42 = ' Therefore, you cannot change node size unless you change AutoSize property.';

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    Edit1: TMenuItem;
    Copytoclipboard1: TMenuItem;
    Deleteselecteditems1: TMenuItem;
    N1: TMenuItem;
    Selectall1: TMenuItem;
    N3: TMenuItem;
    SelectMode1: TMenuItem;
    N4: TMenuItem;
    ZOrder1: TMenuItem;
    Back1: TMenuItem;
    Fore1: TMenuItem;
    MenuItem4: TMenuItem;
    WorkFlow1: TMenuItem;
    Network1: TMenuItem;
    Diagram1: TMenuItem;
    FlowChart1: TMenuItem;
    MenuItem9: TMenuItem;
    Comments1: TMenuItem;
    Zoom1: TMenuItem;
    Zoom100: TMenuItem;
    Zoom150: TMenuItem;
    Zoom75: TMenuItem;
    Zoom0: TMenuItem;
    Capabilities1: TMenuItem;
    MultiSelection1: TMenuItem;
    ReadOnly1: TMenuItem;
    CanSizenode1: TMenuItem;
    CanMovenode1: TMenuItem;
    CanStretchlink1: TMenuItem;
    CanMultilink1: TMenuItem;
    CanDrawnode1: TMenuItem;
    CanDrawlink1: TMenuItem;
    Autoscroll1: TMenuItem;
    DisplayHandles1: TMenuItem;
    MenuItem11: TMenuItem;
    About1: TMenuItem;
    Window1: TMenuItem;
    Cascade1: TMenuItem;
    Tile1: TMenuItem;
    ArrangeIcons1: TMenuItem;
    Memo1: TMemo;
    procedure FormDestroy(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ArrangeIcons1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Copytoclipboard1Click(Sender: TObject);
    procedure Deleteselecteditems1Click(Sender: TObject);
    procedure SelectMode1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Comments1Click(Sender: TObject);
    procedure Zoom100Click(Sender: TObject);
    procedure Zoom150Click(Sender: TObject);
    procedure Zoom75Click(Sender: TObject);
    procedure Zoom0Click(Sender: TObject);
    procedure MultiSelection1Click(Sender: TObject);
    procedure ReadOnly1Click(Sender: TObject);
    procedure CanSizenode1Click(Sender: TObject);
    procedure CanMovenode1Click(Sender: TObject);
    procedure CanStretchlink1Click(Sender: TObject);
    procedure CanMultilink1Click(Sender: TObject);
    procedure CanDrawnode1Click(Sender: TObject);
    procedure CanDrawlink1Click(Sender: TObject);
    procedure Autoscroll1Click(Sender: TObject);
    procedure DisplayHandles1Click(Sender: TObject);
    procedure Back1Click(Sender: TObject);
    procedure Fore1Click(Sender: TObject);
    procedure WorkFlow1Click(Sender: TObject);
    procedure Network1Click(Sender: TObject);
    procedure Diagram1Click(Sender: TObject);
    procedure FlowChart1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations } 
    procedure ActivateForm;
    procedure DeactivateForm;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses Unit1, Unit2, Unit3, Unit4;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange := nil;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  MessageBox(0, 'AddFlow demonstration' + Chr(13) + 'Copyright  1997 Lassalle Technologies', 'Demo', 0);
end;

procedure TMainForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ArrangeIcons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.Selectall1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild.ActiveControl As TAddFlow).SelectAll;
end;

procedure TMainForm.Copytoclipboard1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild.ActiveControl As TAddFlow).SaveImage(1, 0, '');
end;

procedure TMainForm.Deleteselecteditems1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild.ActiveControl As TAddFlow).DeleteSel;
end;

procedure TMainForm.SelectMode1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).SelectMode := Not (ActiveMDIChild.ActiveControl As TAddFlow).SelectMode;
    if (ActiveMDIChild.ActiveControl As TAddFlow).SelectMode = True then
    begin
      SelectMode1.Checked := True;
      (ActiveMDIChild.ActiveControl As TAddFlow).MousePointer := 2;
    end
    else
    begin
      SelectMode1.Checked := False;
      (ActiveMDIChild.ActiveControl As TAddFlow).MousePointer := 0;
    end
  end
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.Comments1Click(Sender: TObject);
begin
  Memo1.Visible := Not Memo1.Visible;
  Comments1.Checked := Memo1.Visible;
end;

procedure TMainForm.Zoom100Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).xZoom := 100;
    (ActiveMDIChild.ActiveControl As TAddFlow).yZoom := 100;
    Zoom100.Checked := True;
  end
end;

procedure TMainForm.Zoom150Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).xZoom := 150;
    (ActiveMDIChild.ActiveControl As TAddFlow).yZoom := 150;
    Zoom150.Checked := True;
  end
end;

procedure TMainForm.Zoom75Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).xZoom := 75;
    (ActiveMDIChild.ActiveControl As TAddFlow).yZoom := 75;
    Zoom75.Checked := True;
  end
end;

procedure TMainForm.Zoom0Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).xZoom := 0;
    (ActiveMDIChild.ActiveControl As TAddFlow).yZoom := 0;
    Zoom0.Checked := True;
  end
end;

procedure TMainForm.MultiSelection1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).MultiSel := Not (ActiveMDIChild.ActiveControl As TAddFlow).MultiSel;
    MultiSelection1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).MultiSel;
  end
end;

procedure TMainForm.ReadOnly1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).ReadOnly := Not (ActiveMDIChild.ActiveControl As TAddFlow).ReadOnly;
    ReadOnly1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).ReadOnly;
    (ActiveMDIChild.ActiveControl As TAddFlow).Refresh;
  end
end;

procedure TMainForm.CanSizenode1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).CanSizeNode := Not (ActiveMDIChild.ActiveControl As TAddFlow).CanSizeNode;
    CanSizenode1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).CanSizeNode;
    (ActiveMDIChild.ActiveControl As TAddFlow).Refresh;
  end
end;

procedure TMainForm.CanMovenode1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).CanMoveNode := Not (ActiveMDIChild.ActiveControl As TAddFlow).CanMoveNode;
    CanMovenode1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).CanMoveNode;
    (ActiveMDIChild.ActiveControl As TAddFlow).Refresh;
  end
end;

procedure TMainForm.CanStretchlink1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).CanStretchLink := Not (ActiveMDIChild.ActiveControl As TAddFlow).CanStretchLink;
    CanStretchlink1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).CanStretchLink;
    (ActiveMDIChild.ActiveControl As TAddFlow).Refresh;
  end
end;

procedure TMainForm.CanMultilink1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).CanMultiLink := Not (ActiveMDIChild.ActiveControl As TAddFlow).CanMultiLink;
    CanMultilink1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).CanMultiLink;
  end
end;

procedure TMainForm.CanDrawnode1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).CanDrawNode := Not (ActiveMDIChild.ActiveControl As TAddFlow).CanDrawNode;
    CanDrawnode1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).CanDrawNode;
  end
end;

procedure TMainForm.CanDrawlink1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).CanDrawLink := Not (ActiveMDIChild.ActiveControl As TAddFlow).CanDrawLink;
    CanDrawlink1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).CanDrawLink;
  end
end;

procedure TMainForm.Autoscroll1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).AutoScroll := Not (ActiveMDIChild.ActiveControl As TAddFlow).AutoScroll;
    Autoscroll1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).AutoScroll;
  end
end;

procedure TMainForm.DisplayHandles1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    (ActiveMDIChild.ActiveControl As TAddFlow).DisplayHandles := Not (ActiveMDIChild.ActiveControl As TAddFlow).DisplayHandles;
    DisplayHandles1.Checked := (ActiveMDIChild.ActiveControl As TAddFlow).DisplayHandles;
    (ActiveMDIChild.ActiveControl As TAddFlow).Refresh;
  end
end;

procedure TMainForm.Back1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    if ((ActiveMDIChild.ActiveControl As TAddFlow).SelectedNode =  nil) And ((ActiveMDIChild.ActiveControl As TAddFlow).SelectedLink = nil) Then
    begin
      { Nothing to do}
    end
    else
    begin
      if (ActiveMDIChild.ActiveControl As TAddFlow).SelectedNode = nil Then
        (ActiveMDIChild.ActiveControl As TAddFlow).SelectedLink.ZOrder := 1
      else
        (ActiveMDIChild.ActiveControl As TAddFlow).SelectedNode.ZOrder := 1
    end
  end
end;

procedure TMainForm.Fore1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
  begin
    if ((ActiveMDIChild.ActiveControl As TAddFlow).SelectedNode = nil) And ((ActiveMDIChild.ActiveControl As TAddFlow).SelectedLink = nil) Then
      { Nothing to do}
    Else
    begin
      If (ActiveMDIChild.ActiveControl As TAddFlow).SelectedNode = nil Then
        (ActiveMDIChild.ActiveControl As TAddFlow).SelectedLink.ZOrder := 0
      Else
        (ActiveMDIChild.ActiveControl As TAddFlow).SelectedNode.ZOrder := 0
    end
  end
end;

procedure TMainForm.WorkFlow1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmWorkFlow, frmWorkFlow);
end;

procedure TMainForm.Network1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmNetwork, frmNetwork);
end;

procedure TMainForm.Diagram1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmDiagram, frmDiagram);
end;

procedure TMainForm.FlowChart1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmFlowChart, frmFlowChart);
end;

procedure TMainForm.ActivateForm;
var
  crlf: string;
begin
  with (ActiveMDIChild.ActiveControl As TAddFlow) do
  begin
    ReadOnly1.Checked := ReadOnly;
    MultiSelection1.Checked := MultiSel;
    CanSizeNode1.Checked := CanSizeNode;
    CanMoveNode1.Checked := CanMoveNode;
    CanStretchLink1.Checked := CanStretchLink;
    CanMultiLink1.Checked := CanMultiLink;
    CanDrawnode1.Checked := CanDrawNode;
    CanDrawlink1.Checked := CanDrawLink;
    AutoScroll1.Checked := AutoScroll;
    case xZoom of
    100: Zoom100.Checked := True;
    150: Zoom150.Checked := True;
    75:  Zoom75.Checked := True;
    0:   Zoom0.Checked := True;
    end;
  end;

  crlf := Chr(13) + Chr(10);
  Case ActiveMDIChild.Tag of
  1: Memo1.Text := INFO11 + crlf + INFO12 + crlf + INFO13 + crlf + INFO14;
  2: Memo1.Text := INFO21 + crlf + INFO22 + crlf + INFO23;
  3: Memo1.Text := INFO31 + crlf + INFO32 + crlf + INFO33 + crlf + INFO34;
  4: Memo1.Text := INFO41 + crlf + INFO42;
  end;
end;

procedure TMainForm.DeactivateForm;
begin
    ReadOnly1.Checked := False;
    MultiSelection1.Checked := False;
    CanSizeNode1.Checked := False;
    CanMoveNode1.Checked := False;
    CanStretchLink1.Checked := False;
    CanMultiLink1.Checked := False;
    CanDrawNode1.Checked := False;
    CanDrawLink1.Checked := False;
    AutoScroll1.Checked := False;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  WorkFlow1.Enabled := False;
  Diagram1.Enabled := False;
  Network1.Enabled := False;
  FlowChart1.Enabled := False;
end;

end.


