unit navig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AddFlowLib_TLB, Menus, StdCtrls;

type
  TfrmNavig = class(TForm)
    AddFlow1: TAddFlow;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Info1: TMenuItem;
    About1: TMenuItem;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure Navigate(navigType: integer);
  end;

var
  frmNavig: TfrmNavig;

implementation

{$R *.DFM}

procedure TfrmNavig.FormCreate(Sender: TObject);
var
  node: array[1..9] of afNode;
  link: afLink;
begin
  with AddFlow1 do
  begin
    { Just to accelerate display (Don't forget to reset it at the end) }
    Repaint := False;

    { Create nodes }
    node[1] := Nodes.Add(1050, 1050, 525, 375);
    node[1].Text := '1';
    node[1].Shape := afRectangle;
    node[1].FillColor := RGB(255, 255, 192);

    node[2] := Nodes.Add(1350, 75, 525, 370);
    node[2].Text := '2';

    node[3] := Nodes.Add(1950, 675, 600, 300);
    node[3].Text := '3';
    
    node[4] := Nodes.Add(2350, 1200, 500, 500);
    node[4].Text := '4';

    node[5] := Nodes.Add(150, 1725, 825, 750);
    node[5].Text := '5: owned by 1';

    node[6] := Nodes.Add(225, 300, 500, 500);
    node[6].Text := '6';
    
    node[7] := Nodes.Add(1250, 2800, 500, 500);
    node[7].Text := '7';

    node[8] := Nodes.Add(2750, 2000, 825, 750);
    node[8].Text := '8: owned by 1';
    
    node[9] := Nodes.Add(2000, 3100, 825, 750);
    node[9].Text := '9: owned by 8';

    { Create links }
    link := node[1].OutLinks.Add(node[2]);
    link := node[1].OutLinks.Add(node[3]);
    link := node[1].OutLinks.Add(node[6]);
    link := node[4].OutLinks.Add(node[1]);
    link := node[5].OutLinks.Add(node[1]);
    link := node[5].OutLinks.Add(node[7]);
    link := node[8].OutLinks.Add(node[1]);
    link := node[9].OutLinks.Add(node[8]);

    { Links that allow ownership beteen nodes }
    link := node[1].OutLinks.Add(node[5]);
    link.Hidden := True;
    link.Rigid := True;
    link.Selectable := False;
    link := node[1].OutLinks.Add(node[8]);
    link.Hidden := True;
    link.Rigid := True;
    link.Selectable := False;
    link := node[8].OutLinks.Add(node[9]);
    link.Hidden := True;
    link.Rigid := True;
    link.Selectable := False;

    Repaint := True;
  end
end;

procedure TfrmNavig.About1Click(Sender: TObject);
begin
  MessageBox(0, 'AddFlow: Navigateation methods sample' + Chr(13) + 'Copyright  1997 Lassalle Technologies', 'Navig', 0);
end;

procedure TfrmNavig.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmNavig.Button2Click(Sender: TObject);
begin
  Navigate(2);
end;

procedure TfrmNavig.Button1Click(Sender: TObject);
begin
  Navigate(1);
end;

procedure TfrmNavig.Button3Click(Sender: TObject);
begin
  Navigate(3);
end;

procedure TfrmNavig.Button4Click(Sender: TObject);
begin
  Navigate(4);
end;

procedure TfrmNavig.Button5Click(Sender: TObject);
begin
  Navigate(5);
end;

procedure TfrmNavig.Button6Click(Sender: TObject);
begin
  Navigate(6);
end;

procedure TfrmNavig.Button7Click(Sender: TObject);
begin
  Navigate(7);
end;

procedure TfrmNavig.Button8Click(Sender: TObject);
begin
  Navigate(8);
end;

procedure TfrmNavig.Button9Click(Sender: TObject);
begin
  Navigate(9);
end;

procedure TfrmNavig.Button10Click(Sender: TObject);
begin
  Navigate(10);
end;

procedure TfrmNavig.Button11Click(Sender: TObject);
begin
  Navigate(11);
end;

procedure TfrmNavig.Button12Click(Sender: TObject);
begin
  Navigate(12);
end;

procedure TfrmNavig.Navigate(navigType: integer);
var
  node: afNode;
  link: afLink;
  i, j: integer;
begin
  { Keep in mind that indexing is 1 based here }
  with AddFlow1 do
  begin
    { Reset draw color of every items (nodes and links) }
    for i := 1 To Nodes.Count Do
    begin
      Nodes.Item(i).DrawColor := RGB(0, 0, 0);
      for j := 1 To Nodes.Item(i).OutLinks.Count do
        Nodes.Item(i).OutLinks.Item(j).DrawColor := RGB(0, 0, 0);
    end;
    
    { Change draw color of various collections of items }
    Case navigType of
    1:
      begin
        for j := 1 To Nodes.Item(1).OutLinks.Count do
        begin
          if Nodes.Item(1).OutLinks.Item(j).Rigid = False then
            Nodes.Item(1).OutLinks.Item(j).Dst.DrawColor := RGB(255, 0, 0);
        end;
        for j := 1 To Nodes.Item(1).InLinks.Count do
        begin
          if Nodes.Item(1).InLinks.Item(j).Rigid = False then
            Nodes.Item(1).InLinks.Item(j).Org.DrawColor := RGB(255, 0, 0);
        end;
      end;
    2:
      for j := 1 To Nodes.Item(1).OutLinks.Count do
      begin
        if Nodes.Item(1).OutLinks.Item(j).Rigid = False then
          Nodes.Item(1).OutLinks.Item(j).Dst.DrawColor := RGB(255, 0, 0);
      end;
    3:
      for j := 1 To Nodes.Item(1).InLinks.Count do
      begin
        if Nodes.Item(1).InLinks.Item(j).Rigid = False then
          Nodes.Item(1).InLinks.Item(j).Org.DrawColor := RGB(255, 0, 0);
      end;
    4:
      begin
        for j := 1 To Nodes.Item(1).OutLinks.Count do
        begin
          if Nodes.Item(1).OutLinks.Item(j).Rigid = False then
            Nodes.Item(1).OutLinks.Item(j).DrawColor := RGB(255, 0, 0);
        end;
        for j := 1 To Nodes.Item(1).InLinks.Count do
        begin
          if Nodes.Item(1).InLinks.Item(j).Rigid = False then
            Nodes.Item(1).InLinks.Item(j).DrawColor := RGB(255, 0, 0);
        end;
      end;
    5:
      for j := 1 To Nodes.Item(1).InLinks.Count do
      begin
        if Nodes.Item(1).InLinks.Item(j).Rigid = False then
          Nodes.Item(1).InLinks.Item(j).DrawColor := RGB(255, 0, 0);
      end;
    6:
      for j := 1 To Nodes.Item(1).OutLinks.Count do
      begin
        if Nodes.Item(1).OutLinks.Item(j).Rigid = False then
          Nodes.Item(1).OutLinks.Item(j).DrawColor := RGB(255, 0, 0);
      end;
    7:
      for j := 1 To Nodes.Item(1).OutLinks.Count do
      begin
        If Nodes.Item(1).OutLinks.Item(j).Rigid = True Then
          Nodes.Item(1).OutLinks.Item(j).Dst.DrawColor := RGB(255, 0, 0);
      end;
    8:   { All nodes }
      for i := 1 To Nodes.Count Do
        Nodes.Item(i).DrawColor := RGB(255, 0, 0);
    9:   { All links }
      for i := 1 To Nodes.Count Do
      begin
        for j := 1 To Nodes.Item(i).OutLinks.Count do
          Nodes.Item(i).OutLinks.Item(j).DrawColor := RGB(255, 0, 0);
      end;
    10:  { All items }
      for i := 1 To Nodes.Count Do
      begin
        Nodes.Item(i).DrawColor := RGB(255, 0, 0);
        for j := 1 To Nodes.Item(i).OutLinks.Count do
          Nodes.Item(i).OutLinks.Item(j).DrawColor := RGB(255, 0, 0);
      end;
    11:  { All selected nodes }
      for i := 1 To Nodes.Count Do
      begin
        if Nodes.Item(i).Selected = True then
          Nodes.Item(i).DrawColor := RGB(255, 0, 0);
      end;
    12:  { All selected links }
      for i := 1 To Nodes.Count Do
      begin
        if Nodes.Item(i).Selected = True then
        begin
          for j := 1 To Nodes.Item(i).OutLinks.Count do
          begin
            if Nodes.Item(i).OutLinks.Item(j).Selected = True then
              Nodes.Item(i).OutLinks.Item(j).DrawColor := RGB(255, 0, 0);
          end;
        end;
      end;
    end
  end 
end;

end.
